diff --git a/InOut/rtauhal.c b/InOut/rtauhal.c
index 5253cdc4679..5317463106e 100644
--- a/InOut/rtauhal.c
+++ b/InOut/rtauhal.c
@@ -288,7 +288,10 @@ int AuHAL_open(CSOUND *csound, const csRtAudioParams * parm,
       prop.mSelector = kAudioHardwarePropertyDevices;
       if (isInput) {
         for(i=0; (unsigned int)  i < devnos; i++) {
-          if((unsigned int) devinfo[i].indevnum == devnum) CoreAudioDev = i;
+          if((unsigned int) devinfo[i].indevnum == devnum) {
+            CoreAudioDev = i;
+            break;
+          }
         }
         if (LIKELY(CoreAudioDev >= 0)) {
           prop.mSelector = kAudioHardwarePropertyDefaultInputDevice;
@@ -316,13 +319,30 @@ int AuHAL_open(CSOUND *csound, const csRtAudioParams * parm,
       }
     }
 
-    for(i=0; (unsigned int)  i < devnos; i++)
-        if(sysdevs[i] == dev){
-          if(isInput) ADC_channels(csound, devinfo[i].inchannels);
-          else DAC_channels(csound, devinfo[i].outchannels);
+    for(i=0; (unsigned int)  i < devnos; i++) {
+      if(sysdevs[i] == dev){
+        if(isInput) {
+          if(devinfo[i].inchannels < parm->nChannels) {
+            csound->ErrorMsg(csound, 
+                             Str(" *** CoreAudio: Device has not enough" 
+                                 " inputs (%d, requested %d)\n"), 
+                             devinfo[i].inchannels, parm->nChannels);
+            return -1;
+          } 
+          ADC_channels(csound, devinfo[i].inchannels);
+        } 
+        else {
+          if(devinfo[i].outchannels < parm->nChannels) {
+            csound->ErrorMsg(csound, 
+                             Str(" *** CoreAudio: Device has not enough"
+                                 " outputs (%d, requested %d)\n"), 
+                             devinfo[i].outchannels, parm->nChannels);
+            return -1;
+          }
+          DAC_channels(csound, devinfo[i].outchannels);
         }
-
-
+      }
+    }   
     csound->Free(csound,sysdevs);
     csound->Free(csound,devinfo);
 
diff --git a/OOps/bus.c b/OOps/bus.c
index a95b92fd601..95d95589805 100644
--- a/OOps/bus.c
+++ b/OOps/bus.c
@@ -1585,13 +1585,13 @@ int32_t chn_k_opcode_init_S(CSOUND *csound, CHN_OPCODE_K *p)
 {
     STRINGDAT *smode = (STRINGDAT *)p->imode;
     int32_t mode;
-    if(!strcmp("rw", smode->data)) {
+    if(!strcmp("rw", smode->data))
         mode = 3;
-    } else if(!strcmp("r", smode->data)) {
+    else if(!strcmp("r", smode->data))
         mode = 1;
-    } else if(!strcmp("w", smode->data)) {
+    else if(!strcmp("w", smode->data))
         mode = 2;
-    } else
+    else
         return csound->InitError(csound, Str("invalid mode, should be r, w, rw"));
     return chn_k_opcode_init_(csound, p, mode);
 }
